#property indicator_chart_window
#property indicator_buffers 2
#property indicator_color1 Lime
#property indicator_color2 Red

double g_ibuf_76[];
double g_ibuf_80[];
bool gi_84;
extern int Nbr_Periods = 10;
extern double Multiplier = 3.0;

int init() {
   SetIndexBuffer(0, g_ibuf_76);
   SetIndexStyle(0, DRAW_LINE, STYLE_SOLID, 2);
   SetIndexLabel(0, "Trend Up");
   SetIndexBuffer(1, g_ibuf_80);
   SetIndexStyle(1, DRAW_LINE, STYLE_SOLID, 2);
   SetIndexLabel(1, "Trend Down");
   return (0);
}

int deinit() {
   return (0);
}

int start() {
   bool li_8;
   bool li_12;
   int lia_16[5000];
   double lda_20[5000];
   double lda_24[5000];
   double ld_28;
   double l_iatr_36;
   int li_44 = IndicatorCounted();
   if (li_44 < 0) return (-1);
   if (li_44 > 0) li_44--;
   int li_0 = Bars - li_44;
   for (int li_4 = li_0; li_4 >= 0; li_4--) {
      l_iatr_36 = iATR(NULL, 0, Nbr_Periods, li_4);
      ld_28 = (High[li_4] + Low[li_4]) / 2.0;
      lda_20[li_4] = ld_28 + Multiplier * l_iatr_36;
      lda_24[li_4] = ld_28 - Multiplier * l_iatr_36;
      lia_16[li_4] = 1;
      if (Close[li_4] > lda_20[li_4 + 1]) {
         lia_16[li_4] = 1;
         if (lia_16[li_4 + 1] == -1) gi_84 = TRUE;
      } else {
         if (Close[li_4] < lda_24[li_4 + 1]) {
            lia_16[li_4] = -1;
            if (lia_16[li_4 + 1] == 1) gi_84 = TRUE;
         } else {
            if (lia_16[li_4 + 1] == 1) {
               lia_16[li_4] = 1;
               gi_84 = FALSE;
            } else {
               if (lia_16[li_4 + 1] == -1) {
                  lia_16[li_4] = -1;
                  gi_84 = FALSE;
               }
            }
         }
      }
      if (lia_16[li_4] < 0 && lia_16[li_4 + 1] > 0) li_8 = TRUE;
      else li_8 = FALSE;
      if (lia_16[li_4] > 0 && lia_16[li_4 + 1] < 0) li_12 = TRUE;
      else li_12 = FALSE;
      if (lia_16[li_4] > 0 && lda_24[li_4] < lda_24[li_4 + 1]) lda_24[li_4] = lda_24[li_4 + 1];
      if (lia_16[li_4] < 0 && lda_20[li_4] > lda_20[li_4 + 1]) lda_20[li_4] = lda_20[li_4 + 1];
      if (li_8 == TRUE) lda_20[li_4] = ld_28 + Multiplier * l_iatr_36;
      if (li_12 == TRUE) lda_24[li_4] = ld_28 - Multiplier * l_iatr_36;
      if (lia_16[li_4] == 1) {
         g_ibuf_76[li_4] = lda_24[li_4];
         if (gi_84 == TRUE) {
            g_ibuf_76[li_4 + 1] = g_ibuf_80[li_4 + 1];
            gi_84 = FALSE;
         }
      } else {
         if (lia_16[li_4] == -1) {
            g_ibuf_80[li_4] = lda_20[li_4];
            if (gi_84 == TRUE) {
               g_ibuf_80[li_4 + 1] = g_ibuf_76[li_4 + 1];
               gi_84 = FALSE;
            }
         }
      }
   }
   return (0);
}
